/*
*********************************************************************************************************
*                                               uC/OS-II
*                                         The Real-Time Kernel
*
*                         (c) Copyright 1998, Jean J. Labrosse, Plantation, FL
*                                          All Rights Reserved
*
*
*                                    68HC11F1 INTERRUPT VECTOR TABLE
*
* File : VECTORS.C
* By   : Jean J. Labrosse
*********************************************************************************************************
*/

#include "INCLUDES.H"

/*
*********************************************************************************************************
*                                              MC68HC11F1
*                                         INTERRUPT VECTOR TABLE
*
* Description: This is the interrupt vector table used by the MC68HC11F1 CPU.  Note that unused
*              interrupts are vectored to NULL.
* Notes      : 1) You MUST define the vector that defines the address of your startup code.
*********************************************************************************************************
*/

void (* const OSVectorTbl[])(void) = {      /* This table begins at 0xFFD6                             */
    (void (*)())NULL,                       /* $FFD6 SCI Serial System                                 */
                                            
    (void (*)())NULL,                       /* $FFD8 SPI Serial Transfer Complete                      */

    (void (*)())NULL,                       /* $FFDA Pulse Accumulator Input Edge                      */

    (void (*)())NULL,                       /* $FFDC Pulse Accumulator Overflow                        */

    (void (*)())NULL,                       /* $FFDE Timer Overflow                                    */

#if OS_TICK_OC == 5
    (void (*)())OSTickISR,                  /* $FFE8 Timer Output Compare 5                            */
#else
    (void (*)())NULL,                       /* $FFE8 Timer Output Compare 5                            */
#endif

#if OS_TICK_OC == 4
    (void (*)())OSTickISR,                  /* $FFE8 Timer Output Compare 4                            */
#else
    (void (*)())NULL,                       /* $FFE8 Timer Output Compare 4                            */
#endif

#if OS_TICK_OC == 3
    (void (*)())OSTickISR,                  /* $FFE8 Timer Output Compare 3                            */
#else
    (void (*)())NULL,                       /* $FFE8 Timer Output Compare 3                            */
#endif

#if OS_TICK_OC == 2
    (void (*)())OSTickISR,                  /* $FFE8 Timer Output Compare 2                            */
#else
    (void (*)())NULL,                       /* $FFE8 Timer Output Compare 2                            */
#endif

#if OS_TICK_OC == 1
    (void (*)())OSTickISR,                  /* $FFE8 Timer Output Compare 1                            */
#else
    (void (*)())NULL,                       /* $FFE8 Timer Output Compare 1                            */
#endif

    (void (*)())NULL,                       /* $FFEA Timer Input Capture 3                             */

    (void (*)())NULL,                       /* $FFEC Timer Input Capture 2                             */

    (void (*)())NULL,                       /* $FFEE Timer Input Capture 1                             */

    (void (*)())NULL,                       /* $FFF0 Real Time Interrupt (RTI)                         */

    (void (*)())NULL,                       /* $FFF2 IRQ (External Pin)                                */

    (void (*)())NULL,                       /* $FFF4 XIRQ Pin (Pseudo Nonmaskable Interrupt)           */

    (void (*)())OSCtxSw,                    /* $FFF6 SWI                                               */

    (void (*)())NULL,                       /* $FFF8 Illegal Opcode Trap                               */

    (void (*)())NULL,                       /* $FFFA COP Failure (Reset)                               */

    (void (*)())NULL,                       /* $FFFC COP Clock Monitor Fail (Reset)                    */

    (void (*)())NULL                        /* $FFFE RESET                                             */
};
