/*******************************************************************
* Librairie de fonctions pour  carte d'affichage 68HC11            *        
*                Stage IUT 1998-99  Y.BENABEN                      *
* Configuration de la carte:                                       *
*   - PORTE : 8 bits en entrees                                    *
*   - PORTA : entrees = PA0,PA1,PA2                                *
*             sorties = PA3,PA4,PA5,PA6,PA7                        *
*******************************************************************/
#include <io.h>

/* dfinition des fonctions*/

/* temporisation en ms */
void tempo (unsigned int msec){ 
unsigned int loop_delay;
loop_delay=msec;
while (msec--) {
	TOC2  = TCNT + loop_delay;
	TFLG1 |= 0x40;                   /* Writing this bit will clear it. */
	while ((TFLG1 & 0x40) == 0x00);  /* Wait until this bit is set. */
		}
}

/* lecture d'un bit du PORTA */
int get1A(unsigned int num_bit){
unsigned int i,mask=1;
for(i=0;i<num_bit;i++){
mask=mask*2;}
return(PORTA & mask);
}

/* lecture d'un bit du PORTE */
int get1E(unsigned int num_bit){
unsigned int i,mask=1;
for(i=0;i<num_bit;i++){
mask=mask*2;}
return(PORTE & mask);
}

/* lecture 8bits du PORTE */
int get8E(){
return(PORTE);
}

/* ecriture de 8 bits sur le PORTA */
void put8A(unsigned int value_byte){
PORTA=value_byte;
}

/* ecriture d'1 bit sur le PORTA */
void put1A(unsigned int num_bit,unsigned int value_bit){
unsigned int i,mask=1;
for(i=0;i<num_bit;i++){
mask=mask*2;}
if (value_bit==1){PORTA=(PORTA | mask);}
if (value_bit==0){PORTA=(PORTA & ~(mask));}


}

/* configuration du port serie: vitesse max =9600bps, vitesse min=1200bps */
void baudrate(unsigned int bps_rate){

SCCR1 = 0x00;   /* 1bit de start, 8bits de donnes, 1 stop, pas de paritee */
SCCR2 = 0x0C;   /* pas d'interruption  */
		/* modes de transmission et de rceptions valids


		/* 8 Mhz       0x30 == 9600 Baud */
		/* 4.9152 Mhz  0x03 == 9600 Baud */
BAUD=0x30;      /* 9600bps  valeur par defaut */

if (bps_rate== 9600){ BAUD=0x30;}
if (bps_rate==4800){BAUD=0x31;}
if (bps_rate==2400){BAUD=0x32;}
if (bps_rate==1200){BAUD=0x33;}

}



/* lecture d'un octet sur le port serie */
char read_com (unsigned char *bait) {
if (SCSR & 0x20) {      /* si RDFR=1 alors on a reu un caractre */
	*bait = SCDR;
	return (1);
}

return (0); /* si pas de caractre, renvoi 0   */
}

/* ecriture d'un octet sur le port serie */
void write_com (unsigned char bait) {
while ((SCSR & 0x80) == 0)      /* on attend que le caractre dans SCDR soit transmis */
	;                       /* avant d'envoyer le nouveau caractre */
SCDR = bait;
}
